{-# LANGUAGE ModalTypes, MultiParamTypeClasses, KindSignatures, FlexibleContexts #-}
-----------------------------------------------------------------------------
-- |
-- Module      :  GHC.HetMet.CodeTypes
-- Copyright   :  none
-- License     :  public domain
--
-- Maintainer  :  Adam Megacz <megacz@acm.org>
-- Stability   :  experimental
-- Portability :  portable
module GHC.HetMet.CodeTypes (
  hetmet_brak,
  hetmet_esc,
  hetmet_csp,
  GuestIntegerLiteral, guestIntegerLiteral,
  GuestStringLiteral, guestStringLiteral,
  GuestCharLiteral, guestCharLiteral
) where

hetmet_brak :: forall (c :: * -> * -> *). forall a. a -> <[a]>@c
hetmet_brak = Prelude.error "hetmet_brak should never be evaluated; did you forget to compile with -fcoqpass?"

hetmet_esc  :: forall (c :: * -> * -> *). forall a. <[a]>@c -> a
hetmet_esc = Prelude.error "hetmet_esc should never be evaluated; did you forget to compile with -fcoqpass?"

hetmet_csp :: forall (c :: * -> * -> *). forall a. a -> a
hetmet_csp = Prelude.error "hetmet_csp should never be evaluated; did you forget to compile with -fcoqpass?"

-- Technically these functions ought to be invoked *during
-- compilation*; in the future I would like to use Template Haskell to
-- do that.
class GuestIntegerLiteral c where
  guestIntegerLiteral :: Integer -> <[ Integer ]>@c
class GuestStringLiteral c where
  guestStringLiteral :: String -> <[ String ]>@c
class GuestCharLiteral c where
  guestCharLiteral :: Char -> <[ Char ]>@c
